Loading...
Searching...
No Matches
pcl::RIFTEstimation< PointInT, GradientT, PointOutT > Class Template Reference
Module features

RIFTEstimation estimates the Rotation Invariant Feature Transform descriptors for a given point cloud dataset containing points and intensity. More...

`#include <pcl/features/rift.h>`

Inheritance diagram for pcl::RIFTEstimation< PointInT, GradientT, PointOutT >:

## Public Types

using | PointCloudIn = pcl::PointCloud<PointInT>
using | PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut
using | PointCloudGradient = pcl::PointCloud<GradientT>
using | PointCloudGradientPtr = typename PointCloudGradient::Ptr
using | PointCloudGradientConstPtr = typename PointCloudGradient::ConstPtr
using | Ptr = shared_ptr<RIFTEstimation<PointInT, GradientT, PointOutT> >
using | ConstPtr = shared_ptr<const RIFTEstimation<PointInT, GradientT, PointOutT> >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase<PointInT>
using | Ptr = shared_ptr< Feature<PointInT, PointOutT> >
using | ConstPtr = shared_ptr< const Feature<PointInT, PointOutT> >
using | KdTree = pcl::search::Search<PointInT>
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud<PointInT>
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud<PointOutT>
using | SearchMethod = std::function<int (std::size_t, double, pcl::Indices &, std::vector<float> &)>
using | SearchMethodSurface = std::function<int (const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector<float> &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| RIFTEstimation ()
| Empty constructor.
void | setInputGradient (const PointCloudGradientConstPtr &gradient)
| Provide a pointer to the input gradient data.
PointCloudGradientConstPtr | getInputGradient () const
| Returns a shared pointer to the input gradient data.
void | setNrDistanceBins (int nr_distance_bins)
| Set the number of bins to use in the distance dimension of the RIFT descriptor.
int | getNrDistanceBins () const
| Returns the number of bins in the distance dimension of the RIFT descriptor.
void | setNrGradientBins (int nr_gradient_bins)
| Set the number of bins to use in the gradient orientation dimension of the RIFT descriptor.
int | getNrGradientBins () const
| Returns the number of bins in the gradient orientation dimension of the RIFT descriptor.
void | computeRIFT (const PointCloudIn &cloud, const PointCloudGradient &gradient, int p_idx, float radius, const pcl::Indices &indices, const std::vector< float > &squared_distances, Eigen::MatrixXf &rift_descriptor)
| Estimate the Rotation Invariant Feature Transform (RIFT) descriptor for a given point based on its spatial neighborhood of 3D points and the corresponding intensity gradient vector field.
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Estimate the Rotation Invariant Feature Transform (RIFT) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), the gradient in setInputGradient (), and the spatial locator in setSearchMethod ().
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

PointCloudGradientConstPtr | gradient_ {nullptr}
| The intensity gradient of the input point cloud data.
int | nr_distance_bins_ {4}
| The number of distance bins in the descriptor.
int | nr_gradient_bins_ {8}
| The number of gradient orientation bins in the descriptor.
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename GradientT, typename PointOutT>
class pcl::RIFTEstimation< PointInT, GradientT, PointOutT >

RIFTEstimation estimates the Rotation Invariant Feature Transform descriptors for a given point cloud dataset containing points and intensity.

For more information about the RIFT descriptor, see:

Svetlana Lazebnik, Cordelia Schmid, and Jean Ponce. A sparse texture representation using local affine regions. In IEEE Transactions on Pattern Analysis and Machine Intelligence, volume 27, pages 1265-1278, August 2005.

Author
  Michael Dixon

Definition at line 59 of file rift.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::ConstPtr = shared_ptr<const RIFTEstimation<PointInT, GradientT, PointOutT> >

Definition at line 79 of file rift.h.

## PointCloudGradient

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudGradient = pcl::PointCloud<GradientT>

Definition at line 74 of file rift.h.

## PointCloudGradientConstPtr

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudGradientConstPtr = typename PointCloudGradient::ConstPtr

Definition at line 76 of file rift.h.

## PointCloudGradientPtr

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudGradientPtr = typename PointCloudGradient::Ptr

Definition at line 75 of file rift.h.

## PointCloudIn

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudIn = pcl::PointCloud<PointInT>

Definition at line 71 of file rift.h.

## PointCloudOut

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 72 of file rift.h.

## Ptr

template<typename PointInT, typename GradientT, typename PointOutT>

using pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::Ptr = shared_ptr<RIFTEstimation<PointInT, GradientT, PointOutT> >

Definition at line 78 of file rift.h.

## Constructor & Destructor Documentation

## RIFTEstimation()

template<typename PointInT, typename GradientT, typename PointOutT>

pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::RIFTEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 83 of file rift.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT, typename GradientT, typename PointOutT>

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Estimate the Rotation Invariant Feature Transform (RIFT) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), the gradient in setInputGradient (), and the spatial locator in setSearchMethod ().

Parameters

  [out] | output | the resultant point cloud model dataset that contains the RIFT feature estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 113 of file rift.hpp.

References computeRIFT(), pcl::Feature< PointInT, PointOutT >::getClassName(), gradient_, pcl::PCLBase< PointInT >::indices_, nr_distance_bins_, nr_gradient_bins_, pcl::Feature< PointInT, PointOutT >::search_radius_, pcl::Feature< PointInT, PointOutT >::surface_, and pcl::Feature< PointInT, PointOutT >::tree_.

## computeRIFT()

template<typename PointInT, typename GradientT, typename PointOutT>

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeRIFT | ( | const PointCloudIn & | cloud,
|  | const PointCloudGradient & | gradient,
|  | int | p_idx,
|  | float | radius,
|  | const pcl::Indices & | indices,
|  | const std::vector< float > & | squared_distances,
|  | Eigen::MatrixXf & | rift_descriptor )

Estimate the Rotation Invariant Feature Transform (RIFT) descriptor for a given point based on its spatial neighborhood of 3D points and the corresponding intensity gradient vector field.

Parameters

  [in] | cloud | the dataset containing the Cartesian coordinates of the points
  [in] | gradient | the dataset containing the intensity gradient at each point in cloud
  [in] | p_idx | the index of the query point in cloud (i.e. the center of the neighborhood)
  [in] | radius | the radius of the RIFT feature
  [in] | indices | the indices of the points that comprise p_idx's neighborhood in cloud
  [in] | squared_distances | the squared distances from the query point to each point in the neighborhood
  [out] | rift_descriptor | the resultant RIFT descriptor

Definition at line 48 of file rift.hpp.

References M_PI.

Referenced by computeFeature().

## getInputGradient()

template<typename PointInT, typename GradientT, typename PointOutT>

PointCloudGradientConstPtr pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getInputGradient | ( |  | ) | const

inline

Returns a shared pointer to the input gradient data.

Definition at line 96 of file rift.h.

References gradient_.

## getNrDistanceBins()

template<typename PointInT, typename GradientT, typename PointOutT>

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrDistanceBins | ( |  | ) | const

inline

Returns the number of bins in the distance dimension of the RIFT descriptor.

Definition at line 106 of file rift.h.

References nr_distance_bins_.

## getNrGradientBins()

template<typename PointInT, typename GradientT, typename PointOutT>

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::getNrGradientBins | ( |  | ) | const

inline

Returns the number of bins in the gradient orientation dimension of the RIFT descriptor.

Definition at line 116 of file rift.h.

References nr_gradient_bins_.

## setInputGradient()

template<typename PointInT, typename GradientT, typename PointOutT>

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setInputGradient | ( | const PointCloudGradientConstPtr & | gradient | ) |

inline

Provide a pointer to the input gradient data.

Parameters

  [in] | gradient | a pointer to the input gradient data

Definition at line 92 of file rift.h.

References gradient_.

## setNrDistanceBins()

template<typename PointInT, typename GradientT, typename PointOutT>

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setNrDistanceBins | ( | int | nr_distance_bins | ) |

inline

Set the number of bins to use in the distance dimension of the RIFT descriptor.

Parameters

  [in] | nr_distance_bins | the number of bins to use in the distance dimension of the RIFT descriptor

Definition at line 102 of file rift.h.

References nr_distance_bins_.

## setNrGradientBins()

template<typename PointInT, typename GradientT, typename PointOutT>

void pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::setNrGradientBins | ( | int | nr_gradient_bins | ) |

inline

Set the number of bins to use in the gradient orientation dimension of the RIFT descriptor.

Parameters

  [in] | nr_gradient_bins | the number of bins to use in the gradient orientation dimension of the RIFT descriptor

Definition at line 112 of file rift.h.

References nr_gradient_bins_.

## Member Data Documentation

## gradient_

template<typename PointInT, typename GradientT, typename PointOutT>

PointCloudGradientConstPtr pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::gradient_ {nullptr}

protected

The intensity gradient of the input point cloud data.

Definition at line 144 of file rift.h.

Referenced by computeFeature(), getInputGradient(), and setInputGradient().

## nr_distance_bins_

template<typename PointInT, typename GradientT, typename PointOutT>

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_distance_bins_ {4}

protected

The number of distance bins in the descriptor.

Definition at line 147 of file rift.h.

Referenced by computeFeature(), getNrDistanceBins(), and setNrDistanceBins().

## nr_gradient_bins_

template<typename PointInT, typename GradientT, typename PointOutT>

int pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::nr_gradient_bins_ {8}

protected

The number of gradient orientation bins in the descriptor.

Definition at line 150 of file rift.h.

Referenced by computeFeature(), getNrGradientBins(), and setNrGradientBins().

The documentation for this class was generated from the following files:

- pcl/features/rift.h
- pcl/features/impl/rift.hpp